import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { ToggleSwitchTypeRender } from './SwitchType/toggle';
import { SingleSwitchTypeRender } from './SwitchType/single';
import { SIZES, TYPES, SUPPORTED_KEYS } from './config';

var AtomSwitch =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(AtomSwitch, _Component);

  function AtomSwitch() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.state = {
      isToggle: _this.props.initialValue,
      isFocus: false,
      isClick: false
    };

    _this._onKeyDown = function (event) {
      if (_this.props.disabled === true) return;

      if (SUPPORTED_KEYS.includes(event.key)) {
        _this._onToggle();

        event.preventDefault();
      }
    };

    _this._onToggle = function (forceValue) {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          onToggle = _this$props.onToggle,
          value = _this$props.value;
      if (disabled === true) return;

      if (value !== undefined) {
        return onToggle(!value);
      }

      var stateToggle = _this.state.isToggle;
      var isToggle = forceValue !== undefined ? forceValue : !stateToggle;

      _this.setState({
        isToggle: isToggle
      }, function () {
        return onToggle(isToggle);
      });
    };

    _this._onBlur = function () {
      _this.setState({
        isFocus: false,
        isClick: false
      });
    };

    _this._onFocus = function (e) {
      setTimeout(function () {
        _this.setState({
          isFocus: true
        });
      }, 150);
    };

    _this._onClick = function (e) {
      _this.setState({
        isClick: true
      });
    };

    return _this;
  }

  var _proto = AtomSwitch.prototype;

  _proto.render = function render() {
    var _this$state = this.state,
        isToggle = _this$state.isToggle,
        isFocus = _this$state.isFocus,
        isClick = _this$state.isClick;

    var commonProps = _objectSpread({}, this.props, {
      isFocus: isFocus,
      isClick: isClick,
      isToggle: isToggle,
      onBlur: this._onBlur,
      onClick: this._onClick,
      onFocus: this._onFocus,
      onKeyDown: this._onKeyDown,
      onToggle: this._onToggle
    });

    return this.props.type === TYPES.SINGLE ? React.createElement(SingleSwitchTypeRender, commonProps) : React.createElement(ToggleSwitchTypeRender, commonProps);
  };

  return AtomSwitch;
}(Component);

AtomSwitch.displayName = 'AtomSwitch';
AtomSwitch.defaultProps = {
  disabled: false,
  initialValue: false,
  labelLeft: 'Off',
  labelRight: 'On',
  size: SIZES.DEFAULT,
  type: TYPES.TOGGLE
};
export default AtomSwitch;